spandsp: fax_modems.h File Reference

spandsp 0.0.6

Typedefs | Enumerations | Functions | Variables
fax_modems.h File Reference

Go to the source code of this file.

## Typedefs
typedef struct fax_modems_state_s | fax_modems_state_t

## Enumerations
enum | { FAX_MODEM_NONE = -1 , FAX_MODEM_FLUSH = 0 , FAX_MODEM_SILENCE_TX , FAX_MODEM_SILENCE_RX , FAX_MODEM_CED_TONE , FAX_MODEM_CNG_TONE , FAX_MODEM_NOCNG_TONE , FAX_MODEM_V21_TX , FAX_MODEM_V17_TX , FAX_MODEM_V27TER_TX , FAX_MODEM_V29_TX , FAX_MODEM_V21_RX , FAX_MODEM_V17_RX , FAX_MODEM_V27TER_RX , FAX_MODEM_V29_RX }

## Functions
const char * | fax_modem_to_str (int modem)
| Convert a FAX modem type to a short text description.
| SPAN_DECLARE_NONSTD (int) fax_modems_v17_v21_rx(void *user_data
| Get the next bit of a transmitted serial bit stream.
| SPAN_DECLARE_NONSTD (void) fax_modems_hdlc_tx_frame(void *user_data
void | fax_modems_start_rx_modem (fax_modems_state_t *s, int which)
void | fax_modems_set_tep_mode (fax_modems_state_t *s, int use_tep)
int | fax_modems_restart (fax_modems_state_t *s)
logging_state_t * | fax_modems_get_logging_state (fax_modems_state_t *s)
| Get a pointer to the logging context associated with a FAX modems context.
fax_modems_state_t * | fax_modems_init (fax_modems_state_t *s, int use_tep, hdlc_frame_handler_t hdlc_accept, hdlc_underflow_handler_t hdlc_tx_underflow, put_bit_func_t non_ecm_put_bit, get_bit_func_t non_ecm_get_bit, tone_report_func_t tone_callback, void *user_data)
int | fax_modems_release (fax_modems_state_t *s)
int | fax_modems_free (fax_modems_state_t *s)

## Variables
const int16_t | amp []
const int16_t int | len
const uint8_t * | msg

## Typedef Documentation

## ◆ fax_modems_state_t

typedef struct fax_modems_state_s fax_modems_state_t

The set of modems needed for FAX, plus the auxilliary stuff, like tone generation.

## Function Documentation

## ◆ fax_modem_to_str()

const char * fax_modem_to_str | ( | int | modem | ) |

Convert a FAX modem type to a short text description.

Convert a FAX modem type to a short text description.

Parameters

  modem | The modem code.

Returns
  A pointer to the description.

## ◆ fax_modems_get_logging_state()

logging_state_t * fax_modems_get_logging_state | ( | fax_modems_state_t * | s | ) |

Get a pointer to the logging context associated with a FAX modems context.

Get a pointer to the logging context associated with a FAX modems context.

Parameters

  s | The FAX modems context.

Returns
  A pointer to the logging context, or NULL.

References fax_modems_state_s::logging.

## ◆ SPAN_DECLARE_NONSTD()

SPAN_DECLARE_NONSTD | ( | int |  | ) |

Get the next bit of a transmitted serial bit stream.

Get the next bit of data from a T.38 rate adapting non-ECM buffer context.

Get a bit of received non-ECM image data.

Process a block of received V.8 audio samples.

Fake processing of a missing block of received V.29 modem audio samples.

Fake processing of a missing block of received V.27ter modem audio samples.

Generate a block of V.22bis modem audio samples.

Fake processing of a missing block of received V.22bis modem audio samples.

Process a block of received V.18 audio samples.

Fake processing of a missing block of received V.17 modem audio samples.

Generate a block of FAX audio samples.

Apply fake received audio processing.

Process a received T.38 IFP packet from a reliable stream (e.g. TCP).

Generate a block of T.31 modem audio samples.

Fake processing of a missing block of received T.31 modem audio samples.

Dummy receive fillin callback.

Dummy receive callback.

Process a block of samples through an instance of the modem connect tones detector.

Get the next sequence of bytes for transmission.

Get the next byte for transmission.

Fake processing of a missing block of received FSK modem audio samples.

Process a block of received FSK modem audio samples.

Apply T.30 transmit processing to generate a block of audio samples.

Apply fake T.30 receive processing.

Get the next bit of a transmitted serial bit stream.

Parameters

  user_data | An opaque point which must point to a transmitter context.

Returns
  the next bit, or PUTBIT_END_OF_DATA to indicate the data stream has ended.

Apply fake T.30 receive processing when a block of audio samples is missing (e.g due to packet loss).

Parameters

  s | The FAX context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed. This should only be non-zero if the software has reached the end of the FAX call.

Apply T.30 transmit processing to generate a block of audio samples.

Parameters

  s | The FAX context.
  amp | The audio sample buffer.
  max_len | The number of samples to be generated.

Returns
  The number of samples actually generated. This will be zero when there is nothing to send.

Process a block of received FSK modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples in the buffer.

Returns
  The number of samples unprocessed.

Fake processing of a missing block of received FSK modem audio samples (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

Parameters

  s | A pointer to an HDLC transmitter context.

Returns
  The next byte for transmission.

Parameters

  s | A pointer to an HDLC transmitter context.
  buf | The buffer for the data.
  max_len | The number of bytes to get.

Returns
  The number of bytes actually got.

Parameters

  s | The context.
  amp | An array of signal samples.
  len | The number of samples in the array.

Returns
  The number of unprocessed samples.

A dummy routine to use as a receive callback, when we aren't really trying to process what is received. It just absorbs and ignores the data.

Parameters

  user_data | The context.
  amp | The signal.buffer
  len | The length of the signal buffer

Returns
  0.

A dummy routine to use as a receive fillin callback, when we aren't really trying to process what is received. It just absorbs and ignores the request.

Parameters

  user_data | The context.
  len | The length of the signal buffer

Returns
  0.

Fake processing of a missing block of received T.31 modem audio samples (e.g due to packet loss).

Parameters

  s | The T.31 modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

Generate a block of T.31 modem audio samples.

Parameters

  s | The T.31 modem context.
  amp | The audio sample buffer.
  max_len | The number of samples to be generated.

Returns
  The number of samples actually generated.

Parameters

  s | The T.38 context.
  buf | The packet contents.
  len | The length of the packet contents.
  seq_no | The packet sequence number, used for logging purposes.

Returns
  The length of the packet processed, or -1 if there is an error in the packet, or too few bytes of data to complete it.

Apply fake processing when a block of audio samples is missing (e.g due to packet loss).

Parameters

  s | The T.38 context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed. This should only be non-zero if the software has reached the end of the FAX call.

Generate a block of FAX audio samples.

Parameters

  s | The T.38 context.
  amp | The audio sample buffer.
  max_len | The number of samples to be generated.

Returns
  The number of samples actually generated.

Fake processing of a missing block of received V.17 modem audio samples. (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

Process a block of received V.18 audio samples.

Parameters

  s | The V.18 context.
  amp | The audio sample buffer.
  len | The number of samples in the buffer.

Fake processing of a missing block of received V.22bis modem audio samples. (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

Generate a block of V.22bis modem audio samples.

Parameters

  s | The modem context.
  amp | The audio sample buffer.
  len | The number of samples to be generated.

Returns
  The number of samples actually generated.

Fake processing of a missing block of received V.27ter modem audio samples. (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

Fake processing of a missing block of received V.29 modem audio samples. (e.g due to packet loss).

Parameters

  s | The modem context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed.

Process a block of received V.8 audio samples.

Parameters

  s | The V.8 context.
  amp | The audio sample buffer.
  len | The number of samples in the buffer.

Get the next bit of a transmitted serial bit stream.

Apply T.30 transmit processing to generate a block of audio samples.

Apply fake T.30 receive processing.

Apply T.30 receive processing to a block of audio samples.

Parameters

  s | The FAX context.
  amp | The audio sample buffer.
  len | The number of samples in the buffer.

Returns
  The number of samples unprocessed. This should only be non-zero if the software has reached the end of the FAX call.

Apply fake T.30 receive processing when a block of audio samples is missing (e.g due to packet loss).

Parameters

  s | The FAX context.
  len | The number of samples to fake.

Returns
  The number of samples unprocessed. This should only be non-zero if the software has reached the end of the FAX call.

Apply T.30 transmit processing to generate a block of audio samples.

Parameters

  s | The FAX context.
  amp | The audio sample buffer.
  max_len | The number of samples to be generated.

Returns
  The number of samples actually generated. This will be zero when there is nothing to send.